clc, clear all, close all 
%% Controlli Automatici   
%% Esercitazione 1, 2, 3 in Malab 
% 
% P(s) f.d.t. Ambiente da condizionare 
P=tf(0.1,[1000 70 1]); 
% G(s) f.d.t. Valvola per il controllo della Portata 
G=tf(1,[10 1]); 
% C1(s) f.d.t. Regolatore Proporzionale del Loop di Portata  
C1=tf(100); 
% H1(s) f.d.t. Sensore di Portata (es. Venturimetro) 
H1=1; 
% W1(s) f.d.t. Loop di Portata 
W1=feedback(C1*G,H1); 
% C2(s) f.d.t. Regolatore Loop di Temperatura 
kc2=1; 
C2=tf(kc2*[100 1],[1 0]); 
% H1(s) f.d.t. Sensore di Temperatura  
H2=tf(1,[1 1]);                 
%% 1.   Confrontare i diagrammi di risposta armonica ed indiciale delle  
% f.d.t. I/U e D/U nellipotesi di trascurare o meno il loop di controllo 
% interno di portata e si facciano le considerazioni del caso; 
  
% F.d.t. I/U 
Wr=feedback(C2*W1*P,H2); 
Wr_ap1=feedback(C2*P,H2);  
figure(1) 
    bode(Wr,Wr_ap1) 
figure(2) 
    step(Wr,Wr_ap1) 
% F.d.t. Disturbo/Uscita 
Wdt=feedback(1,C2*W1*P*H2); 
Wdt_ap1=feedback(1,C2*P*H2); 
figure(3) 
    bode(Wdt,Wdt_ap1) 
figure(4) 
    step(Wdt,Wdt_ap1) 
  
Wdq=1/(C1*G)*feedback(W1*P,C2*W1*P*H2); 
Wdq_ap1=1/(C1*G)*feedback(P,C2*P*H2); 
figure(5) 
    bode(Wdq,Wdq_ap1) 
figure(6) 
    step(Wdq,Wdq_ap1) 
%% 2.   Verificare se sia possibile dare, una rappresentazione semplificata 
% della f.d.t. I/U della mediante un sistema del secondo ordine; 
[numWr,denWr]=tfdata(Wr,'v') 
roots(numWr) 
roots(denWr) 
Wr_ap2=tf(1,conv([1/(-0.0245 + 0.0980i) -1],[1/(-0.0245 - 0.0980i) -1])) 
  
figure(7) 
    bode(Wr,Wr_ap1,Wr_ap2) 
%%  3. Si valuti la stabilit del sistema a ciclo chiuso al variare del  
% guadagno kc2 ?[0,+?] del controllore di temperatura C_2 (s)  
% utilizzando sia i diagrammi Bode che di Nyquist nellipotesi di  
% trascurare o meno il loop di controllo interno di portata; 
% F.d.t. ad anello del loop esterno 
F=C2*W1*P*H2; 
F_ap1=C2*P*H2; 
  
figure(8) 
    bode(F,F_ap1) 
figure(9) 
    nyquist(F,F_ap1) 
  
  
%% 4.   Valutare i margini di guadagno e di fase del sistema, nonch la  
% pulsazione critica ed il guadagno critico; 
  
help margin 
[Gm,Pm,omega_180,omega_t] = margin(F) 
  
figure(10) 
subplot(1,2,1) 
    margin(F) 
subplot(1,2,2) 
    margin(F_ap1) 
 
%% 5.   Si analizzino le caratteristiche modali del sistema a ciclo chiuso  
% al variare del guadagno k_(C_2 )?[0,+?) del controllore di temperatura 
% C2(s) utilizzando il luogo delle radici     
 
zpk(F) 
kprimoF=0.1
zeriF=zero(F)
poliF=pole(F)
n=5; 
m=1 
phi=zeros(n-m,1) 
% calcolo asintoti  
for h=0:1:n-m-1 
    phi(h+1)=(2*h+1)*180/(n-m); 
end 
  
phi 
   
syms s 
  
XD=solve('1/(s+0.01) - ( 1/s + 1/(s+10.1) +1/(s+1) + 1/(s+0.05)+ 1/(s+0.02) )=0') 

% Esempio utilizzo formula di taratura fissiamo s pari al punto di
% diramazione:
s=XD(3)
% il guadagno K tale per cui il luogo si trava nel punto di diramazione 
% per dettagli sulla seguente istruzione digitare 
help prod   % moltiplica tra loro gli elementi di un vettore
help abs    % calcola il valore assoluto dell'argomento
help lenght % fornisce la lunghezza di un vettore
K = prod(abs(s - poliF) )/(kprimoF*prod(abs(s-zeriF)))
% confrontare questo risultato sul luogo delle radici

figure(11) 
    rlocus(F) 
    
% Dal lugo delle radici  inoltre possibile notare che il punto
s=j*0.234
% appartiene al luogo. Dalla struttura del luogo si evince inoltre che il
% sistema  al limite di stabilit. Utilizzando la formula di taratura
% possiamo inoltre valutare il guadagno KC2 per il quale il sistema a ciclo
% chiuso sar al limite di stabilit
K = prod(abs(s - poliF) )/(kprimoF*prod(abs(s-zeriF))) 
% come si pu notare il valore ottenuto  molto prossimo al margine di
% quadagno calcolato al punto 4
Gm

%% [X] Esercizio bonus: Data la f.d.t.
clear all
Fnew=zpk([1],[-1 j -j],1)
zeriF=zero(Fnew)
poliF=pole(Fnew)
% calcolare la fase iniziale del luogo nel punto s=+j
s=j
% attraverso la forumla delle fasi del luogo:
phase_rad= sum( rad2deg( phase( s - poliF )) ) + rad2deg(  phase( s - zeriF) ) 
% come possiamo vedere la fase  270 che coincide con la fase iniziale del
% luogo delle radici
figure(20)
    rlocus(Fnew)
